%define _vboxrel %(cat build_release)
%define kmodtool bash %{SOURCE10}
%{!?kver: %define kver 4.1.12-94.3.4.el6uek}
%{!?kversion: %define kversion %{kver}.%{_target_cpu}}

%define kmod_name vboxguest
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define kvariants uek4
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 

Name:           kmod-%{kmod_name}
Version:        %{_vboxrel}
Release: 	1%{?dist}
Summary:        %{kmod_name} kernel modules

Group:          System Environment/Kernel
License:        GPLv2
URL:            http://www.virtualbox.org
Source0:        vboxguest-kmod-%{version}.tar.gz
Source10:	kmodtool-%{kmod_name}-%{kvariants}-el6.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  x86_64
BuildRequires:  kernel-uek-devel = %{kver}

%description
VirtualBox Linux guest kernel modules for Oracle Linux 6 UEK4

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    %{__mkdir} -p _kmod_build_$kvariant
    %{__cp} -a src/vboxguest-%{version}/Makefile src/vboxguest-%{version}/vboxguest src/vboxguest-%{version}/vboxsf src/vboxguest-%{version}/vboxvideo _kmod_build_$kvariant
done
echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" > filter-requires.sh
echo "override vboxguest * extra/%{kmod_name}" >> kmod-%{kmod_name}-%{kvariants}.conf
echo "override vboxsf * extra/%{kmod_name}" >> kmod-%{kmod_name}-%{kvariants}.conf
echo "override vboxvideo * extra/%{kmod_name}" >> kmod-%{kmod_name}-%{kvariants}.conf

%build
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}
    cd _kmod_build_$kvariant
    %{__make} KERN_DIR="${KSRC}" KERN_VER=%{kversion} %{?_smp_mflags}
    cd ..
done

%install
%{__rm} -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}
    cd _kmod_build_$kvariant
    %{__make} -C vboxguest modules_install KERN_DIR="${KSRC}" KERN_VER=%{kversion}
    %{__make} -C vboxsf    modules_install KERN_DIR="${KSRC}" KERN_VER=%{kversion}
    %{__make} -C vboxvideo modules_install KERN_DIR="${KSRC}" KERN_VER=%{kversion}
    cd ..
    # Cleanup unnecessary kernel-generated module dependency files.
    find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done

%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}-%{kvariants}.conf %{buildroot}%{_sysconfdir}/depmod.d/

# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;

%post
/sbin/depmod -a

%clean
%{__rm} -rf %{buildroot}

%changelog
